#!/bin/bash

if [ -z "$1" ]; then
    echo "Usage: $0 <kernel ver>"
    exit -1
fi

KERNEL_VERSION="$1"
KERNEL_SRC="/usr/src/linux-$KERNEL_VERSION"
TMPDIR=$(pwd)/tmp/build_kernel
BUILDDIR=$TMPDIR/linux-$KERNEL_VERSION
INSTDIR=$TMPDIR

if [ ! -d $KERNEL_SRC ]; then
    echo "Kernel source $KERNEL_SRC not exists."
    exit -2
fi

echo "Build dir is $BUILDDIR"

mkdir -p $BUILDDIR
#rm -rf $INSTDIR/kmodules

pushd $KERNEL_SRC
#zcat $(SRCDIR)/xxx.patch.gz | patch -p1
#cp $(SRCDIR)/linux-$KERNEL_VERSION.config .config

#make O=$BUILDDIR oldconfig

echo Do config
make O=$BUILDDIR xconfig
echo Press Ctrl-C to exit
read anykey

echo Making kernel
make -j 2 O=$BUILDDIR

echo Installing modules
rm -rf $INSTDIR/kmodules
make O=$BUILDDIR \
    INSTALL_MOD_PATH=$INSTDIR/kmodules \
    modules_install
if [ "$?" = "0" ] ; then
    cp $BUILDDIR/arch/i386/boot/bzImage $INSTDIR/mb-vmlinuz-$KERNEL_VERSION
    tar -C $INSTDIR/kmodules -cjf $INSTDIR/kmodules-$KERNEL_VERSION.tar.bz2 .
    echo "Done! Files are in $INSTDIR"
else
    echo "Failed!"
    exit -1
fi
popd

if [ "$2" == "install" ]; then
    cp $INSTDIR/mb-vmlinuz-$KERNEL_VERSION bindir/
    cp $INSTDIR/kmodules-$KERNEL_VERSION.tar.bz2 bindir/
fi
# <EOF>
