#############################################################
#
# pciutils
#
#############################################################
PCIUTILS_VERSION=2.2.1
PCIUTILS_SOURCE:=pciutils-$(PCIUTILS_VERSION).tar.bz2
PCIUTILS_SITE:=ftp://ftp.kernel.org/pub/software/utils/pciutils
PCIUTILS_DIR:=$(BUILD_DIR)/pciutils-$(PCIUTILS_VERSION)
PCIUTILS_CAT:=bzcat
PCIUTILS_CFLAGS:=-D_GNU_SOURCE=1 -Os -Wall -W -Wno-parentheses -Wstrict-prototypes -Wmissing-prototypes -Winline -fPIC

PCIUTILS_BINARY:=pciutils
PCIUTILS_TARGET_BINARY:=usr/bin/pciutils

$(DL_DIR)/$(PCIUTILS_SOURCE):
	 $(WGET) -P $(DL_DIR) $(PCIUTILS_SITE)/$(PCIUTILS_SOURCE)

pciutils-source: $(DL_DIR)/$(PCIUTILS_SOURCE)

$(PCIUTILS_DIR)/.unpacked: $(DL_DIR)/$(PCIUTILS_SOURCE)
	$(PCIUTILS_CAT) $(DL_DIR)/$(PCIUTILS_SOURCE) | tar -C $(BUILD_DIR) $(TAR_OPTIONS) -
	touch $(PCIUTILS_DIR)/.unpacked

$(PCIUTILS_DIR)/.patched: $(PCIUTILS_DIR)/.unpacked
	toolchain/patch-kernel.sh $(PCIUTILS_DIR) package/pciutils/ pciutils\*.patch
	touch $(PCIUTILS_DIR)/.patched

$(PCIUTILS_DIR)/.configured: $(PCIUTILS_DIR)/.patched
	touch $(PCIUTILS_DIR)/.configured

$(PCIUTILS_DIR)/lib/libpci.a: $(PCIUTILS_DIR)/.configured
	make -C $(PCIUTILS_DIR) PREFIX=/usr IDSDIR=/usr/share/hwdata \
		$(TARGET_CONFIGURE_OPTS) CFLAGS="$(PCIUTILS_CFLAGS)" lib/libpci.a

$(STAGING_DIR)/lib/libpci.a: $(PCIUTILS_DIR)/lib/libpci.a
	install -m 644 $(PCIUTILS_DIR)/lib/libpci.a $(STAGING_DIR)/lib;
	install -m 755 -d $(STAGING_DIR)/include/pci
	for header in config.h header.h pci.h types.h ; do \
		install -m 644 $(PCIUTILS_DIR)/lib/$$header $(STAGING_DIR)/include/pci ; \
	done

pciutils: uclibc $(STAGING_DIR)/lib/libpci.a

pciutils-clean:
	-$(MAKE) -C $(PCIUTILS_DIR) distclean
	rm -f $(PCIUTILS_DIR)/.configured

pciutils-dirclean:
	rm -rf $(PCIUTILS_DIR)
#############################################################
#
# Toplevel Makefile options
#
#############################################################
ifeq ($(strip $(BR2_PACKAGE_PCIUTILS)),y)
TARGETS+=pciutils
endif
