#!/usr/bin/python
# Copyright (C) 2003, Charles Wang.
# Author:  Charles Wang <charles@linux.net.cn>
# All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANT; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public LIcense for more
# details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, 59 Temple
# Place - Suite 330, Boston, MA 02111-1307, USA.

import mi_core

def select(bindir, fromdir, todir):
    ver = '2.3.4-1mgc'
    mi_core.system("rm -rf %s; mkdir -p %s" % (fromdir, fromdir))
    mi_core.rpminst(bindir, fromdir, 'glibc-%s.i686.rpm' % ver)
    mi_core.select(fromdir, todir,
                   ['lib/ld-2.3.4.so', 'lib/ld-linux.so.2',
                    'lib/libc-2.3.4.so', 'lib/libc.so.6',
                    'lib/libm-2.3.4.so', 'lib/libm.so.6',
                    'lib/libdl-2.3.4.so', 'lib/libdl.so.2',
                    'lib/libnsl-2.3.4.so', 'lib/libnsl.so.1',
                    'lib/libnss_compat-2.3.4.so', 'lib/libnss_compat.so.2',
                    'lib/libnss_files-2.3.4.so', 'lib/libnss_files.so.2',
                    'lib/libpthread-0.10.so', 'lib/libpthread.so.0',
                    'lib/libresolv-2.3.4.so', 'lib/libresolv.so.2',
                    'lib/librt-2.3.4.so', 'lib/librt.so.1',
                    'lib/libutil-2.3.4.so', 'lib/libutil.so.1',
                    'sbin/ldconfig'],
                   [])
    # Setup locale data.
    mi_core.rpminst(bindir, fromdir, 'gzip-1.3.3-13mgc.i686.rpm')
    mi_core.rpminst(bindir, fromdir, 'tzdata-2005m-1mgc.noarch.rpm')
    mi_core.rpminst(bindir, fromdir, 'glibc-common-%s.i386.rpm' % ver)
    #mi_core.system("/usr/sbin/chroot %s localedef -i en_US -f ISO8859-1 en_US.ISO8859-1" % fromdir)
    #mi_core.system("/usr/sbin/chroot %s localedef -i en_US -f UTF-8 en_US.UTF8" % fromdir)
    mi_core.system("/usr/sbin/chroot %s localedef -i zh_CN -f GB18030 zh_CN.GB18030" % fromdir)
    mi_core.system("/usr/sbin/chroot %s localedef -i zh_CN -f GB2312 zh_CN.GB2312" % fromdir)
    mi_core.system("/usr/sbin/chroot %s localedef -i zh_CN -f UTF-8 zh_CN.UTF8" % fromdir)
    mi_core.select(fromdir, todir,
                   ['usr/lib/locale/locale-archive',
                    'usr/lib/gconv/gconv-modules*',
                    'usr/lib/gconv/ISO8859-1.so',
                    'usr/lib/gconv/EUC-CN.so',
                    'usr/lib/gconv/libGB.so',
                    'usr/lib/gconv/GB18030.so',
                    'usr/share/locale/locale.alias',
                    'usr/share/zoneinfo/zone.tab',
                    'usr/share/zoneinfo/Asia/Shanghai',
                    'usr/share/zoneinfo/posix/Asia/Shanghai',
                    'usr/share/zoneinfo/right/Asia/Shanghai'],
                   [])
