/* Copyright (C) 2003, Charles Wang.
 * Author:  Charles Wang <charles@linux.net.cn>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANT; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public LIcense for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include <stdio.h>
#include "proc-parser.h"

cpuinfo_struct    cpuinfo;
meminfo_struct    meminfo;
filesystem_array  filesystems;
ide_array         ides;
scsi_array        scsis;
partition_array   partitions;

int main(void) {
    if (parse_cpuinfo(&cpuinfo))
	fprintf(stderr, "parse_cpuinfo failed.\n");
    if (parse_meminfo(&meminfo))
	fprintf(stderr, "parse_meminfo failed.\n");
    if (parse_filesystems(&filesystems))
	fprintf(stderr, "parse_filesystems failed.\n");
    if (parse_ides(&ides))
	fprintf(stderr, "parse_ides failed.\n");
    if (parse_scsis(&scsis))
	fprintf(stderr, "parse_scsis failed.\n");
    if (parse_partitions(&partitions))
	fprintf(stderr, "parse_partitions failed.\n");
    return 0;
}
